//% color="#4169E1" iconWidth=50 iconHeight=40
namespace cvshow{



    
    //% block="初始化摄像头并设置帧缓冲 " blockType="command"
    export function init(parameter: any, block: any){
        Generator.addCode(`cap = cv2.VideoCapture(0)`)
        Generator.addCode(`cap.set(cv2.CAP_PROP_BUFFERSIZE, 1)`)

    }

    //% block="每[SEC]毫秒刷新图像" blockType="command"
    //% SEC.shadow="number"   SEC.defl="1"
    export function refrash(parameter: any, block: any){
        let sec = parameter.SEC.code
        Generator.addCode(`key = cv2.waitKey(${sec})`)
    }


    //% block="对象名[CONV]将图片[RSC]的颜色反转" blockType="command"
    //% RSC.shadow="normal"   RSC.defl="img"
    //% CONV.shadow="normal"   CONV.defl="img"
    export function bitwise(parameter: any, block: any){
        let rsc = parameter.RSC.code
        let conv = parameter.CONV.code
        Generator.addCode(`${conv} = cv2.bitwise_not(src=${rsc})`)
    }


    //% block="对象名[NM]在图片[IMG]上绘制文字[TEXT]位置[LOC]大小[SIZ]" blockType="command"
    //% NM.shadow="normal"   NM.defl="res"
    //% IMG.shadow="normal"   IMG.defl="img"
    //% TEXT.shadow="normal"   TEXT.defl="text"
    //% LOC.shadow="normal"   LOC.defl="(0,0)"
    //% SIZ.shadow="normal"   SIZ.defl="0.8"
    export function puttext(parameter: any, block: any){
        let nm = parameter.NM.code
        let img = parameter.IMG.code
        let text = parameter.TEXT.code
        let loc = parameter.LOC.code
        let siz = parameter.SIZ.code
        Generator.addCode(`
${nm} = cv2.putText(${img}, 
    ${text}, 
    ${loc},
    cv2.FONT_HERSHEY_SIMPLEX, ${siz}, 
    (0, 255, 0), 
    2, 
    cv2.LINE_4)
        `)
    }


    //%block="对象名[IMG2]用opencv将图片[IMG1]剪裁为宽[WID]高[HEI]"blockType="command"
    //% IMG1.shadow="normal"   IMG1.defl="img"
    //% IMG2.shadow="normal"   IMG2.defl="img"
    //% WID.shadow="number"   WID.defl="123"
    //% HEI.shadow="number"   HEI.defl="123"
    export function resize(parameter: any, block: any){
        let img1 = parameter.IMG1.code
        let img2 = parameter.IMG2.code
        let wid = parameter.WID.code
        let hei = parameter.HEI.code
        Generator.addCode(`${img2} = cv2.resize(${img1},(${wid},${hei})) `);
        
    }


    //%block="对象[IMG4]调整图像[IMG3]大小为[SIZ]"blockType="command"
    //% IMG3.shadow="normal"   IMG3.defl="img"
    //% IMG4.shadow="normal"   IMG4.defl="img"
    //% SIZ.shadow="normal"   SIZ.defl="[0:130, 0:255]"
    export function crop(parameter: any, block: any){
        let img3 = parameter.IMG3.code
        let img4 = parameter.IMG4.code
        let siz = parameter.SIZ.code
        Generator.addCode(`${img4} = ${img3}${siz} `)
        
    }

    //%block="获取图片[FRAME]的高h 宽w 通道数c"blockType="command"
    //% FRAME.shadow="normal"   FRAME.defl="img"
    export function shape(parameter: any, block: any){
        let frame = parameter.FRAME.code
        Generator.addCode(`h, w, c = ${frame}.shape`);
        
    }

    //%block="创建窗口[WIN]并设置为全屏"blockType="command"
    //% WIN.shadow="normal"   WIN.defl="winname"
    export function window(parameter: any, block: any){
        let win = parameter.WIN.code
        Generator.addCode(`cv2.namedWindow('${win}',cv2.WND_PROP_FULLSCREEN)`);
        Generator.addCode(`cv2.setWindowProperty('${win}', cv2.WND_PROP_FULLSCREEN, cv2.WINDOW_FULLSCREEN)`);

    }
}